; d0=card
; d1=pos
drawcard:
        cmp.b #CALC_TI89,CALCULATOR
        beq drawcard89

        movem.l d0-d7/a0-a6,-(a7)

        move.l d1,d2

        bsr getsuitnum

        cmp.l #4,d1
        beq specialcard

        move.l gplane1,a0
        bsr drawframe
        bsr drawnum
        bsr drawsuit

        move.l gplane0,a0
        bsr drawframe

        cmp.l #2,d1
        blt drawdone

        bsr drawcopyplane
        bra drawdone

specialcard:
        cmp.l #1,d0
        bgt drawempty

        move.l gplane1,a0
        bsr drawframe
        move.l gplane0,a0
        bsr drawframe

        move.l gplane1,a0
        move.l gplane0,a1
        move.l #suitbits,a2
        add.l #112,a2
        add.l d2,a0
        add.l d2,a1
        add.l #30,a0
        add.l #30,a1
        move.l #25,d3
        move.l gplane1,a3      ;LCD_MEM
        add.l #STATUS_LINE_OFS,a3
backloop:
        move.b (a2)+,(a0)+
        move.b (a2)+,(a1)+
        move.b (a2)+,(a0)+
        move.b (a2)+,(a1)+
        move.b (a2)+,(a0)+
        move.b (a2)+,(a1)+
        add.l #27,a0
        add.l #27,a1
        cmp.l a3,a0
        bge drawdone
        cmp.b #0,(a2)
        bne backloopnext
        move.l #suitbits,a2
        add.l #112,a2
backloopnext:
        dbra d3,backloop

        bra drawdone

drawempty:
        move.l gplane1,a0
        move.l gplane0,a1
        add.l d2,a0
        add.l d2,a1
        move.l #13,d3
        move.l gplane1,a3    ;LCD_MEM
        add.l #STATUS_LINE_OFS,a3
drawemptyloop:
        move.b #$aa,d4
        move.b d4,(a1)+
        move.b d4,(a1)+
        move.b d4,(a1)+
        add.l #27,a1
        clr.b (a0)+
        clr.b (a0)+
        clr.b (a0)+
        add.l #27,a0
        cmp.l a3,a0
        bge drawdone
        move.b #$55,d4
        move.b d4,(a1)+
        move.b d4,(a1)+
        move.b d4,(a1)+
        add.l #27,a1
        clr.b (a0)+
        clr.b (a0)+
        clr.b (a0)+
        add.l #27,a0
        cmp.l a3,a0
        bge drawdone
        dbra d3,drawemptyloop

        cmp.l #3,d0
        bne drawdone

        move.l d2,d3
        divu.w #30,d3
        move.l d3,d4
        and.l #$ffff,d3
        lsr.l #8,d4
        lsr.l #8,d4
        lsl.l #3,d4

        move.w #2,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7

        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #4,-(a7)
        move.w d3,-(a7)
        add.w #10,(a7)
        move.w d4,-(a7)
        add.w #8,(a7)
        move.w #'X',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7

drawdone:
        movem.l (a7)+,d0-d7/a0-a6
        rts


drawframe:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        add.l d2,a1

        move.b #$ff,(a1)+
        move.b #$ff,(a1)+
        move.b #$ff,(a1)+
        add.l #27,a1
        cmp.l d7,a1
        bge drawframedone

        move.l #25,d3
drawframeloop:
        move.b #$80,(a1)+
        move.b #$00,(a1)+
        move.b #$01,(a1)+
        add.l #27,a1
        cmp.l d7,a1
        bge drawframedone
        dbra d3,drawframeloop

        move.b #$ff,(a1)+
        move.b #$ff,(a1)+
        move.b #$ff,(a1)+
        add.l #27,a1

drawframedone:
        rts

drawnum:
        move.l d2,d3
        divu.w #30,d3
        move.l d3,d4
        and.l #$ffff,d3
        lsr.l #8,d4
        lsr.l #8,d4
        lsl.l #3,d4

        clr.l tempstr
        move.l #6,d5

        move.b #'A',tempstr

        cmp.l #1,d0
        beq drawnum_ok
        cmp.l #10,d0
        beq drawnum_10
        cmp.l #11,d0
        beq drawnum_J
        cmp.l #12,d0
        beq drawnum_Q
        cmp.l #13,d0
        beq drawnum_K

        move.b #'0',tempstr
        add.b d0,tempstr
        bra drawnum_ok

drawnum_10:
        move.w #$3130,tempstr
        move.l #12,d5
        bra drawnum_ok

drawnum_J:
        move.b #'J',tempstr
        bra drawnum_ok

drawnum_Q:
        move.b #'Q',tempstr
        bra drawnum_ok

drawnum_K:
        move.b #'K',tempstr

drawnum_ok:
        movem.l d0-d2/a0-a1,-(a7)

        cmp.l #119,d3
        bge drawnumdone

        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        move.w #4,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #2,(a7)
        move.w d4,-(a7)
        add.w #1,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        cmp.l #102,d3
        bge drawnumdone

        move.w #4,-(a7)
        move.l #tempstr,-(a7)
        move.w d3,-(a7)
        add.w #19,(a7)
        move.w d4,-(a7)
        add.w #22,(a7)
        sub.w d5,(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

drawnumdone:
        movem.l (a7)+,d0-d2/a0-a1
        rts

drawsuit:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        add.l d2,a1
        add.l #60,a1
        cmp.l d7,a1
        bge drawsuitdone1
        move.l #suitbits,a2
        move.l d1,d3
        mulu.w #28,d3
        add.l d3,a2
        move.l #6,d3
drawsuitloop1:
        add.l #1,a1
        move.b (a2)+,d4
        or.b d4,(a1)+
        move.b (a2)+,d4
        or.b d4,(a1)+
        add.l #27,a1
        cmp.l d7,a1
        bge drawsuitdone1
        dbra d3,drawsuitloop1

drawsuitdone1:
        move.l a0,a1
        add.l d2,a1
        add.l #570,a1
        cmp.l d7,a1
        bge drawsuitdone2
        move.l #6,d3
drawsuitloop2:
        move.b (a2)+,d4
        or.b d4,(a1)+
        move.b (a2)+,d4
        or.b d4,(a1)+
        add.l #28,a1
        cmp.l d7,a1
        bge drawsuitdone2
        dbra d3,drawsuitloop2

drawsuitdone2:
        rts

drawcopyplane:
        move.l a0,d7
        add.l #STATUS_LINE_OFS,d7

        move.l a0,a1
        move.l gplane1,a2
        add.l d2,a1
        add.l d2,a2
        move.l #27,d3
drawcopyloop:
        move.b (a2)+,(a1)+
        move.b (a2)+,(a1)+
        move.b (a2)+,(a1)+
        add.l #27,a1
        add.l #27,a2
        cmp.l d7,a1
        bge drawcopydone
        dbra d3,drawcopyloop
drawcopydone:
        rts
        
        include "drawcard.inc"

