inputstr:
        move.b #0,(a0)
        move.l d1,d6
        move.l d2,d5
        move.l #0,d7
        move.l a0,a6
        movem.l d0-d7/a6,-(a7)
        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        movem.l (a7)+,d0-d7/a6
        movem.l d5-d7/a6,-(a7)
        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #0,-(a7)
        move.w d1,-(a7)
        move.w d2,-(a7)
        move.w #'_',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7
        movem.l (a7)+,d5-d7/a6
inputloop:
        bsr blackbottom
        movem.l d5-d7/a6,-(a7)
        bsr idle_loop
        and.l #$ffff,d0
        movem.l (a7)+,d5-d7/a6
        cmp.w #257,d0
        beq input_backspace
        cmp.w #13,d0
        beq input_enter
        cmp.w #32,d0
        beq input_char
        cmp.w #'0',d0
        blt inputloop
        cmp.w #'9',d0
        ble input_char
        cmp.w #'A',d0
        blt inputloop
        cmp.w #'Z',d0
        ble input_char
        cmp.w #'a',d0
        blt inputloop
        cmp.w #'z',d0
        ble input_char
        bra inputloop

input_enter:
        move.l d7,d3
        cmp.l #0,d3
        beq inputloop
        rts

input_backspace:
        move.l d7,d3
        cmp.l #0,d3
        beq inputloop
        sub.l #1,d3
        move.l d3,d4
        mulu.w #6,d4
        add.l d5,d4
        sub.l #1,d7
        movem.l d5-d7/a6,-(a7)
        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #0,-(a7)
        move.l d6,d1
        move.w d1,-(a7)
        move.w d4,-(a7)
        move.w #'_',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7
        movem.l (a7)+,d5-d7/a6
        movem.l d5-d7/a6,-(a7)
        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #0,-(a7)
        move.l d6,d1
        move.w d1,-(a7)
        add.w #6,d4
        move.w d4,-(a7)
        move.w #' ',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7
        movem.l (a7)+,d5-d7/a6
        move.l a6,a1
        add.l d7,a1
        move.b #0,(a1)
        bra inputloop
input_char:
        move.l d7,d3
        cmp.l #12,d3
        bge inputloop
        move.l a6,a1
        add.l d3,a1
        move.b d0,(a1)+
        move.b #0,(a1)
        move.l d3,d4
        mulu.w #6,d4
        add.l d5,d4
        add.l #1,d7
        movem.l d5-d7/a6,-(a7)
        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #0,-(a7)
        move.l d6,d1
        move.w d1,-(a7)
        move.w d4,-(a7)
        move.w d0,-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7
        movem.l (a7)+,d5-d7/a6
        movem.l d5-d7/a6,-(a7)
        move.w #$00ff,-(a7)
        move.w #$0000,-(a7)
        move.w #$00ff,-(a7)
        move.w #0,-(a7)
        move.l d6,d1
        move.w d1,-(a7)
        add.w #6,d4
        move.w d4,-(a7)
        move.w #'_',-(a7)
        jsr tios::DrawCharXY
        add.l #14,a7
        movem.l (a7)+,d5-d7/a6
        bra inputloop

blackbottom:
        move.l gplane1,a0
        add.l #3660,a0
        move.l #179,d0
bbloop:
        move.b #$ff,(a0)+
        dbra d0,bbloop
        rts

dohigh1:
        bsr drawtitle

        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        move.w #0,-(a7)
        move.l #strx_score+21,-(a7)
        move.w #HISCORE1_Y,-(a7)
        move.w #HISCORE1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.w #0,-(a7)
        move.l #strx_score+100,-(a7)
        move.w #HISCORE2_Y,-(a7)
        move.w #HISCORE2_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l a0,-(a7)
        add.l #HINAME1+16,(a7)
        move.l a0,-(a7)
        add.l #HINAME1+32,(a7)
        jsr tios::sprintf
        add.l #8,a7
        move.l stats(pc),a0
        move.l a0,-(a7)
        add.l #HINAME1,(a7)
        move.l a0,-(a7)
        add.l #HINAME1+16,(a7)
        jsr tios::sprintf
        add.l #8,a7
        move.l stats(pc),a0
        move.l HISCORE1+4(a0),d0
        move.l d0,HISCORE1+8(a0)
        move.l HISCORE1(a0),d0
        move.l d0,HISCORE1+4(a0)

        move.w #HISCORE3_Y,d1
        move.w #HISCORE3_X,d2
        move.l stats(pc),a0
        add.l #HINAME1,a0
        bsr inputstr
        move.l score(pc),d0
        move.l stats(pc),a0
        move.l d0,HISCORE1(a0)

        bra startover

dohigh2:
        bsr drawtitle

        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        move.w #0,-(a7)
        move.l #strx_score+47,-(a7)
        move.w #HISCORE1_Y,-(a7)
        move.w #HISCORE1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.w #0,-(a7)
        move.l #strx_score+100,-(a7)
        move.w #HISCORE2_Y,-(a7)
        move.w #HISCORE2_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.l stats(pc),a0
        move.l a0,-(a7)
        add.l #HINAME1+16,(a7)
        move.l a0,-(a7)
        add.l #HINAME1+32,(a7)
        jsr tios::sprintf
        add.l #8,a7
        move.l stats(pc),a0
        move.l HISCORE1+4(a0),d0
        move.l d0,HISCORE1+8(a0)

        move.w #HISCORE3_Y,d1
        move.w #HISCORE3_X,d2
        move.l stats(pc),a0
        add.l #HINAME1+16,a0
        bsr inputstr
        move.l score(pc),d0
        move.l stats(pc),a0
        move.l d0,HISCORE1+4(a0)

        bra startover

dohigh3:
        bsr drawtitle

        move.w #1,-(a7)
        jsr tios::FontSetSys
        add.l #2,a7
        move.w #0,-(a7)
        move.l #strx_score+74,-(a7)
        move.w #HISCORE1_Y,-(a7)
        move.w #HISCORE1_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7
        move.w #0,-(a7)
        move.l #strx_score+100,-(a7)
        move.w #HISCORE2_Y,-(a7)
        move.w #HISCORE2_X,-(a7)
        jsr tios::DrawStrXY
        add.l #10,a7

        move.w #HISCORE3_Y,d1
        move.w #HISCORE3_X,d2
        move.l stats(pc),a0
        add.l #HINAME1+32,a0
        bsr inputstr
        move.l score(pc),d0
        move.l stats(pc),a0
        move.l d0,HISCORE1+8(a0)

        bra startover
